#include <windows.h>
#include "2dclean_sse.h"
#include "ppixels_smp.h"



unsigned __int64 Bound_Mask[7] = {
	0xffffffffffffffffi64,
	0xffffffffffffff00i64,
	0xffffffffffff0000i64,
	0xffffffffff000000i64,
	0x00ffffffffffffffi64,
	0x0000ffffffffffffi64,
	0x000000ffffffffffi64,
};

unsigned __int64 Bound_Mask_SSE[7] = {
	0xffffffffffffffffi64,
	0xffffffffffff0000i64,
	0xffffffff00000000i64,
	0xffff000000000000i64,
	0x0000ffffffffffffi64,
	0x00000000ffffffffi64,
	0x000000000000ffffi64,
};

unsigned __int64 bytemask = 0x8080808080808080i64;
unsigned __int64 bytemask2 = 0x7f7f7f7f7f7f7f7fi64;

extern "C"	unsigned int divtable2[128], n_by_22[128];

DWORD WINAPI TwoCleanYV12_smp(void * my_data_args)
{
	HANDLE event;
	struct thread_data *mydata;
	int		radiusX, radiusY;
	int		fDebugNoise;
	int		multfact,pitchm;
	int		thresh;
	int		width,height;
	unsigned char *bsrcp;
	unsigned char  *bdstp;
	int		src_modulo, dst_modulo;
	int		plane;

	mydata = (struct thread_data *) my_data_args;

	event			= mydata->event;
	thresh			= mydata->thresh_yv;
	bsrcp			= mydata->bsrcp;
	bdstp			= mydata->bdstp;
	fDebugNoise		= mydata->fDebugNoise;
	radiusX			= mydata->radiusX;
	radiusY			= mydata->radiusY;
	multfact		= mydata->multfact;
	pitchm			= mydata->pitchm;
	width			= mydata->width;
	height			= mydata->height;
	src_modulo		= mydata->src_modulo;
	dst_modulo		= mydata->dst_modulo;
	plane			= mydata->plane;

	if(plane == PLANAR_Y)
	{
		ppixels_y(thresh, bsrcp, bdstp, fDebugNoise, radiusX, radiusY, multfact, pitchm, width, height, src_modulo, dst_modulo);
	}
	else
	{
		ppixels_c(thresh, bsrcp, bdstp, fDebugNoise, radiusX, radiusY, multfact, pitchm, width, height, src_modulo, dst_modulo);
	}

	SetEvent (event);
	return 0;
}

int __stdcall ppixels_y(int	Thresh,
							unsigned char	*srcp,
							unsigned char	*dstp,
							int				fDebugNoise,
							int				radiusX,
							int				radiusY,
							int				multfact,
							int				pitchm,
							int				width,
							int				height,
							int				src_modulo,
							int				dst_modulo
						 )
{
	int		x,y;
	int		loopY,lowY,highY,countY;
	BYTE	*cptr,*tmpp,cpixels[8],*cpixelsptr;
	int		pitch;
	int		thre;
	WORD	sum[8], count[8], nby2[8];
	WORD	*sum_lo, *sum_hi, *count_lo, *count_hi,*nby2_lo,*nby2_hi;
	int		bound0;
	int		i;
	WORD	sum1, count1;

	multfact--;
	bound0 = width % 8?0:1;
	thre = -Thresh;
	pitch  = pitchm << multfact;
	sum_lo = &sum[0];
	sum_hi = &sum[4];
	count_lo = &count[0];
	count_hi = &count[4];
	nby2_lo = &nby2[0];
	nby2_hi = &nby2[4];
	sum1=count1=0;
	tmpp = srcp;
	cpixelsptr=&cpixels[0];

	_asm
	{
					mov			eax, Thresh
					and			eax, 0xff
					movd		mm7, eax
					punpcklbw	mm7, mm7
					punpcklwd	mm7, mm7
					punpckldq	mm7, mm7			; mm7 <-- -Threshold
					mov			eax, Thresh
					and			eax, 0xff
					movd		mm6, eax
					punpcklbw	mm6, mm6
					punpcklwd	mm6, mm6
					punpckldq	mm6, mm6			; mm6 <-- Threshold
					pxor		mm5, mm5			; mm5 <-- 0
	}
	for(y=0;y<height;y++)
	{
		lowY = y - (radiusY << multfact);
		if( lowY < 0 ) lowY = 0;
		highY = y + (radiusY << multfact);
		if( highY > height -1  ) highY = height - 1;
		countY = ((highY - lowY + 1) >> multfact);
		lowY -= y;
// x=0
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel_LeftBound(-2)	
				Add_Counter()
				Read_RoundPixel_LeftBound(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel(1)
				Add_Counter()
				Read_RoundPixel(2)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel()
			srcp+=8;
			dstp+=8;
// x=8-
		for(x=8;x<width-8;x+=8)
		{
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel(-2)
				Add_Counter()
				Read_RoundPixel(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel(1)
				Add_Counter()
				Read_RoundPixel(2)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel()
			srcp+=8;
			dstp+=8;
		}
// x=width-8
		if(bound0)
		{
// bound_right=8 pixel
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel(-2)
				Add_Counter()
				Read_RoundPixel(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel_RightBound(1)
				Add_Counter()
				Read_RoundPixel_RightBound(2)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel()
			srcp+=8;
			dstp+=8;
		}
		else
		{
// bound_right=4 pixel
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel(-2)
				Add_Counter()
				Read_RoundPixel(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel_RightBound(1)
				Add_Counter()
				Read_RoundPixel_RightBound(2)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel4()
			srcp+=4;
			dstp+=4;
		}
		srcp += src_modulo;
		tmpp += src_modulo;
		dstp += dst_modulo;
	}
	return 0;
}

int __stdcall ppixels_c(int	Thresh,
							unsigned char	*srcp,
							unsigned char	*dstp,
							int				fDebugNoise,
							int				radiusX,
							int				radiusY,
							int				multfact,
							int				pitchm,
							int				width,
							int				height,
							int				src_modulo,
							int				dst_modulo
						 )
{
	int		x,y;
	int		loopY,lowY,highY,countY;
	unsigned char	*bsrcp, *bdstp;
	BYTE	*cptr,*tmpp,cpixels[8],*cpixelsptr;
	int		pitch;
	int		thre;
	WORD	sum[8], count[8], nby2[8];
	WORD	*sum_lo, *sum_hi, *count_lo, *count_hi,*nby2_lo,*nby2_hi;
	int		bound0;
	int		i;
	WORD	sum1, count1;

	multfact--;
	bound0 = width % 8;
	thre = -Thresh;
	pitch  = pitchm;
	sum_lo = &sum[0];
	sum_hi = &sum[4];
	count_lo = &count[0];
	count_hi = &count[4];
	nby2_lo = &nby2[0];
	nby2_hi = &nby2[4];
	sum1=count1=0;
	tmpp = srcp;
	cpixelsptr=&cpixels[0];
	bsrcp = srcp;
	bdstp = dstp;

	_asm
	{
					mov			eax, Thresh
					and			eax, 0xff
					movd		mm7, eax
					punpcklbw	mm7, mm7
					punpcklwd	mm7, mm7
					punpckldq	mm7, mm7			; mm7 <-- -Threshold
					mov			eax, Thresh
					and			eax, 0xff
					movd		mm6, eax
					punpcklbw	mm6, mm6
					punpcklwd	mm6, mm6
					punpckldq	mm6, mm6			; mm6 <-- Threshold
					pxor		mm5, mm5			; mm5 <-- 0
	}
	for(y=0;y<height;y++)
	{
		multfact?lowY = y - radiusY:lowY = y - (radiusY >> 2);
		if( lowY < 0 ) lowY = 0;
		multfact?highY = y + radiusY:highY = y + (radiusY >> 2);
		if( highY > height -1  ) highY = height - 1;
		countY = highY - lowY + 1;
		lowY -= y;
// x=0
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel_LeftBound(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel(1)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel()
			srcp+=8;
			dstp+=8;
// x=8-
		for(x=8;x<width-8;x+=8)
		{
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel(1)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel()
			srcp+=8;
			dstp+=8;
		}
// x=width-8
		if(bound0==0)
		{
// bound_right=8 pixel
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel_RightBound(1)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				sum[i] = *(srcp + i);
				count[i] = 1;
				count[i] = divtable2[count[i]];
			}
			Store_Pixel()
			srcp+=8;
			dstp+=8;
		}
		else if(bound0==4)
		{
// bound_right=4 pixel
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel_RightBound(1)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel4()
			srcp+=4;
			dstp+=4;
		}
		else
		{
// bound_right=2 pixel
			cptr = srcp + lowY * pitchm;
			Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr)
			for(loopY=0;loopY<countY;loopY++)
			{
				Read_RoundPixel(-1)
				Add_Counter()
				Read_RoundPixel(0)
				Add_Counter()
				Read_RoundPixel_RightBound(1)
				Add_Counter()
				cptr += pitch;
			}
			for(i=0;i<8;i++)
			{
				count[i] = divtable2[count[i]];
			}
			Store_Pixel2()
			srcp+=2;
			dstp+=2;
		}
		srcp = bsrcp + pitch;
		bsrcp = srcp;
		dstp = bdstp + pitch;
		bdstp = dstp;
	}
	return 0;
}

